#!/usr/bin/env python

import struct
import socket

HOST = ''                 # Symbolic name meaning all available interfaces
PORT = 53032              # Port that the Polaris AIS is sending data to

POLARIS_AIS_UDP_SIZE = 1448

with socket.socket(socket.AF_INET, socket.SOCK_DGRAM) as s:
    s.bind((HOST, PORT))
    while True:
        data = s.recv(POLARIS_AIS_UDP_SIZE)
        seq_nr = struct.unpack("<Q", data[:8]) # Unpack sequence number
        iq_samples = struct.unpack("<" + "h" * 720, data[8:]) # Unpack signed shorts
        i0 = iq_samples[0::8] # Starting from 0 every 8 sample is from channel I0
        q0 = iq_samples[1::8] # Starting from 1 every 8 sample is from channel Q0
        i1 = iq_samples[2::8] # Starting from 2 every 8 sample is from channel I1
        q1 = iq_samples[3::8] # Starting from 3 every 8 sample is from channel Q1
        i2 = iq_samples[4::8] # Starting from 4 every 8 sample is from channel I2
        q2 = iq_samples[5::8] # Starting from 5 every 8 sample is from channel Q2
        i3 = iq_samples[6::8] # Starting from 6 every 8 sample is from channel I3
        q3 = iq_samples[7::8] # Starting from 7 every 8 sample is from channel Q3
        print(f"Seq. nr. {seq_nr[0]}, {i0[0]:+06d}, {q0[0]:+06d}, {i1[0]:+06d}, {q1[0]:+06d}, {i2[0]:+06d}, {q2[0]:+06d}, {i3[0]:+06d}, {q3[0]:+06d}")
